﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections.ObjectModel;

namespace KeyedCollectionExample
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
            


        }

        private void StringKey()
        {
            textBoxOutarea.Text = "";
            StringOrder weekly = new StringOrder();

            // The Add method, inherited from Collection, takes OrderItem.
            //
            weekly.Add(new OrderItem(110072674, "Widget", 400, 45.17));
            weekly.Add(new OrderItem(110072675, "Sprocket", 27, 5.3));
            weekly.Add(new OrderItem(101030411, "Motor", 10, 237.5));
            weekly.Add(new OrderItem(110072684, "Gear", 175, 5.17));

            Display(weekly);// The Contains method of KeyedCollection takes the key, 
            // type, in this case int.
            //
            OutArea = String.Format("\nContains({1}): {0}",
                weekly.Contains("Motor"), "Motor");

            // The default Item property of KeyedCollection takes a key.
            //
            OutArea = String.Format("\nweekly[{1}].PartNumber: {0}",
                weekly["Motor"].PartNumber, "Motor");

            // The Remove method of KeyedCollection takes a key.
            //
            OutArea = String.Format("\nRemove({0})", "Motor");
            weekly.Remove("Motor");
            Display(weekly);

            // The Insert method, inherited from Collection, takes an 
            // index and an OrderItem.
            //
            OutArea = "\nInsert(2, New OrderItem(...))";
            weekly.Insert(2, new OrderItem(111033401, "Nut", 10, .5));
            Display(weekly);

            // The default Item property is overloaded. One overload comes
            // from KeyedCollection<int, OrderItem>; that overload
            // is read-only, and takes String because it retrieves by key. 
            // The other overload comes from Collection<OrderItem>, the 
            // base class of KeyedCollection<int, OrderItem>; it 
            // retrieves by index, so it also takes an Integer. 
            //
            OutArea = "";
            OutArea = "No cast is needed, since the two keys have different types";
            OutArea = "KeyedCollection is by String, Collection is by int";
            OutArea = "";
            OutArea = String.Format("\ncoweekly[2].Description: {0}",
                weekly[2].Description);

            OutArea = "\ncoweekly[2] = new OrderItem(...)";
            weekly[2] = new OrderItem(127700026, "Crank", 27, 5.98);

            OrderItem temp = weekly[2];

            // The IndexOf method inherited from Collection<OrderItem> 
            // takes an OrderItem instead of a key
            // 
            OutArea = String.Format("\nIndexOf(temp): {0}", weekly.IndexOf(temp));

            // The inherited Remove method also takes an OrderItem.
            //
            OutArea = "\nRemove(temp)";
            weekly.Remove(temp);
            Display(weekly);

            OutArea = "\nRemoveAt(0)";
            weekly.RemoveAt(0);
            Display(weekly);
        }

        private void IntegerKey()
        {
            textBoxOutarea.Text = "";
            SimpleOrder weekly = new SimpleOrder();

            // The Add method, inherited from Collection, takes OrderItem.
            //
            weekly.Add(new OrderItem(110072674, "Widget", 400, 45.17));
            weekly.Add(new OrderItem(110072675, "Sprocket", 27, 5.3));
            weekly.Add(new OrderItem(101030411, "Motor", 10, 237.5));
            weekly.Add(new OrderItem(110072684, "Gear", 175, 5.17));

            Display(weekly);// The Contains method of KeyedCollection takes the key, 
            // type, in this case int.
            //
            OutArea = String.Format("\nContains(101030411): {0}",
                weekly.Contains(101030411));

            // The default Item property of KeyedCollection takes a key.
            //
            OutArea = String.Format("\nweekly[101030411].Description: {0}",
                weekly[101030411].Description);

            // The Remove method of KeyedCollection takes a key.
            //
            OutArea = "\nRemove(101030411)";
            weekly.Remove(101030411);
            Display(weekly);

            // The Insert method, inherited from Collection, takes an 
            // index and an OrderItem.
            //
            OutArea = "\nInsert(2, New OrderItem(...))";
            weekly.Insert(2, new OrderItem(111033401, "Nut", 10, .5));
            Display(weekly);

            // The default Item property is overloaded. One overload comes
            // from KeyedCollection<int, OrderItem>; that overload
            // is read-only, and takes Integer because it retrieves by key. 
            // The other overload comes from Collection<OrderItem>, the 
            // base class of KeyedCollection<int, OrderItem>; it 
            // retrieves by index, so it also takes an Integer. The compiler
            // uses the most-derived overload, from KeyedCollection, so the
            // only way to access SimpleOrder by index is to cast it to
            // Collection<OrderItem>. Otherwise the index is interpreted
            // as a key, and KeyNotFoundException is thrown.
            //
            Collection<OrderItem> coweekly = weekly;
            OutArea = String.Format("\ncoweekly[2].Description: {0}",
                coweekly[2].Description);

            OutArea = "\ncoweekly[2] = new OrderItem(...)";
            coweekly[2] = new OrderItem(127700026, "Crank", 27, 5.98);

            OrderItem temp = coweekly[2];

            // The IndexOf method inherited from Collection<OrderItem> 
            // takes an OrderItem instead of a key
            // 
            OutArea = String.Format("\nIndexOf(temp): {0}", weekly.IndexOf(temp));

            // The inherited Remove method also takes an OrderItem.
            //
            OutArea = "\nRemove(temp)";
            weekly.Remove(temp);
            Display(weekly);

            OutArea = "\nRemoveAt(0)";
            weekly.RemoveAt(0);
            Display(weekly);
        }

        public String OutArea
        {
            set { textBoxOutarea.Text += value + "\n\r"; }
        }

        private void Display(SimpleOrder order)
        {
            OutArea = "";
            foreach (OrderItem item in order)
            {
                OutArea = item.ToString();
                OutArea = "";
            }
        }

        private void Display(StringOrder order)
        {
            OutArea = "";
            foreach (OrderItem item in order)
            {
                OutArea = item.ToString();
                OutArea = "";
            }
        }

        private void buttonInteger_Click(object sender, EventArgs e)
        {
            IntegerKey();
        }

        private void buttonString_Click(object sender, EventArgs e)
        {
            StringKey();
        }

    }
}
